<template>
    <div>
        <div class="loading" v-if="loading">
            <p id="loadd">LOADING...</p>
        </div>
        <div id="item-P">
            <label id="dataL">Dia:</label>
            <input type="date" class="dataS" id="dataDia" v-model="dataR" v-on:input="getData()" required>
        </div>
        <div>
            <label id="clientL">Client:</label>
            <input list="clientsL" id="clients" style="text-transform:uppercase" name="clients" v-on:click="deleteValue('clients')" v-on:input="getCentres()" required >
            <datalist id="clientsL"></datalist>
        </div>
        <div>
            <label id="centreL">Centre:</label>
            <input list="centresL" id="centres" name="centres" style="text-transform:uppercase" v-on:click="deleteValue('centres')" v-on:input="getLlistar()" disabled required >
            <datalist id="centresL"></datalist>
        </div>
        <div class="container">
            <div class="card mostrarTasca">
                <div class="card-header">Afegir tasca</div>
                <div class="card-body">
                    <table id="tTasques">
                        <tr>
                            <td class="campT">
                                <b>Nom del treballador/a</b>
                            </td>
                            <td class="campT">
                                <b>Tasca assignada</b>
                            </td>
                            <td class="campT">
                                <b>Unitats</b>
                            </td>
                            <td class="campT">
                                <b>Temps real</b>
                            </td>
                            <td class="campT">
                                <b>Eliminar</b>
                            </td>
                        </tr>
                        <tr v-for="tasca in tascaFeines" v-bind:key="tasca.id">
                            <td class="campT" v-text="tasca.treballador_id"></td>
                            <td class="campT" v-text="tasca.concepte_id"></td>
                            <td class="campT" v-text="tasca.unitats"></td>
                            <td class="campT" v-text="tasca.tempsRealTotal"></td>
                            <td class="campT">
                                <button class="btn btn-danger"><span class="glyphicon glyphicon-trash" v-on:click="eliminar(tasca.id)"></span></button>
                            </td>
                        </tr>
                    </table>
                    <button class="btn btn-primary btn-v" id="btn-validar" type="submit" v-on:click="validarConceptes()" >
                        <span class="glyphicon glyphicon-plus"></span> Validar
                    </button>
                </div>
            </div>
            <div class="card afegirTasca">
                <div class="card-header">Afegir tasca</div>
                <div class="card-body">
                    <div class="dada" id="primer">
                        <label>Tasques</label>
                        <input list="tasquesL" id="tasques" name="tasques" v-on:click="deleteValue('tasques')" disabled required>
                        <datalist id="tasquesL"></datalist>
                        <div class="error" id="tasquesE">
                            <p>Aquest camp és obligatori</p>
                        </div>
                    </div>

                    <div class="dada">
                        <label for>Treballador</label>
                        <input list="treballadorsL" id="treballadors" name="treballadors" required>
                        <datalist id="treballadorsL"></datalist>
                        <div class="error" id="treballadorE">
                            <p>Aquest camp és obligatori</p>
                        </div>
                    </div>
                    <div class="dada">
                        <label for>Unitats</label>
                        <input type="number" id="unitats" required>
                        <div class="error" id="unitatsE">
                            <p>Aquest camp és obligatori</p>
                        </div>
                    </div>
                    <div class="dada">
                        <label>Temps teòric unitari:</label>
                        <input type="time" id="tempsTeoricUnitari" required>
                    </div>
                    <div class="dada">
                        <label>Temps teòric total:</label>
                        <input type="time" id="tempsTeoricTotal" required>
                        <div class="error" id="tempsTeoricTotalE">
                            <p>Aquest camp és obligatori</p>
                        </div>
                    </div>
                    <div class="dada">
                        <label>Temps real total:</label>
                        <input type="time" id="tempsRealTotal" required>
                    </div>
                    <div class="dada">
                        <button class="btn btn-success btn-guardar" id="btn-afegir" type="submit" v-on:click="guardarD()">
                            <span class="glyphicon glyphicon-plus"></span> Afegir tasca
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    props: ["user", "ruta"],
    mounted() {
        console.log("Component mounted.");
    },
    data: function() {
        return {
            clientsL: [],
            centresL: [],
            tascaFeines: [],
            tasquesC: [],
            tasquesT: [],
            totesTasques: [],
            treballadorsT: [],
            totsTreballadors: [],
            feinaTreballador: [],
            feinaTreballador: {
                client_id: null,
                centre_id: null,
                treballador_id: null,
                concepte_id: null,
                data: null,
                unitats: null,
                tempsTeoricUnitari: null,
                tempsTeoricTotal: null,
                tempsRealTotal: null,
                actiu: null
            },
            loading: false,
            idClient: null,
            idCentre: null,
            dataR: ""
        };
    },
    methods: {
        eliminar($id){
            axios
            .get(this.ruta + '/api/eliminarFeina/' + $id)
            .then(response => {
                this.loading = true;
                this.getData()
            });
        },
        deleteValue($inputC) {
            if($inputC == 'tasques'){
                document.getElementById($inputC).value = "";
            }else if($inputC == 'clients'){
                document.getElementById($inputC).value = "";
                document.getElementById('centresL').innerHTML = "";
                document.getElementById('centres').disabled = true;
            }else if($inputC == 'centres'){
                document.getElementById($inputC).value = "";
                document.getElementById('tasquesL').innerHTML = "";
                document.getElementById("tasques").value = "";
                document.getElementById("tasques").disabled = true;
            }
        },
        getData() {
            document.getElementById("tempsTeoricUnitari").value = "00:00";
            document.getElementById("tempsTeoricTotal").value = "00:00";
            document.getElementById("tempsRealTotal").value = "00:00";
            this.getDataDia();
            this.getClients();
            this.getTreballadors();
            this.getLlistar();
        },
        getDataDia() {
            var dataA = this.dataR; //document.getElementById('dataDia').value;
            if (dataA == "") {
                var d = new Date();
                var curr_date = d.getDate();
                var curr_month = d.getMonth() + 1; //Months are zero based
                var curr_year = d.getFullYear();
                if (curr_month < 10) {
                    curr_month = "0" + curr_month;
                }
                if (curr_date < 10) {
                    curr_date = "0" + curr_date;
                }
                dataA = curr_year + "-" + curr_month + "-" + curr_date;
                this.dataR = dataA;
            }
        },
        getClients() {
            var clientsL = document.getElementById("clientsL");
            var text = "";
            axios.get(this.ruta + "/api/clientsL").then(response => {
                this.clientsL = response.data;
                for (let i = 0; i < this.clientsL.length; i++) {
                    text += '<option value="' + this.clientsL[i].nomClient + '">';
                }
                clientsL.innerHTML = text;
                text = "";
            });
        },
        getLlistar() {
            this.loading = true;
            this.getTasques();
            this.llistarTasques();
        },
        getCentres() {
            this.loading = true;
            var client = document.getElementById("clients").value;
            var centresL = document.getElementById("centresL");
            document.getElementById("centres").disabled = false;
            var text = "";
            var sortir = false;
            var i = 0;
            while (i < this.clientsL.length && sortir == false) {
                if (this.clientsL[i].nomClient == client) {
                    sortir = true;
                } else {
                    i++;
                }
            }
            if (sortir == false) {
                this.loading = false;
            } else {
                this.idClient = this.clientsL[i].id;
                axios
                .get(this.ruta + "/api/centresbyidclient/" + this.clientsL[i].id)
                .then(response => {
                    this.centresL = response.data;
                    for (let i = 0; i < this.centresL.length; i++) {
                        text += '<option value="' + this.centresL[i].nomCentre + '">';
                    }
                    centresL.innerHTML = text;
                    text = "";
                })
                .finally(() => (this.loading = false));
            }
        },
        getTasques() {
            var tasquesL = document.getElementById("tasquesL");
            var centre = document.getElementById("centres").value;
            document.getElementById("tasques").disabled = false;
            var text = "";
            var j = 0;
            var k = 0;
            var sortir = false;
            var fi = false;
            var l = 0;
            while (l < this.centresL.length && sortir == false) {
                if (this.centresL[l].nomCentre == centre) {
                    sortir = true;
                } else {
                    l++;
                }
            }
            if (sortir == true) {
                sortir = false;
                this.idCentre = this.centresL[l].id;
                axios.get(this.ruta + "/api/tasques").then(response => {
                    this.totesTasques = response.data;
                    axios
                    .get(this.ruta + "/api/conceptescentre/" + this.idClient + "-" + this.idCentre)
                    .then(response => {
                        this.tasquesC = response.data;
                        this.limit = this.tasquesC.length;
                        var dataDia = this.dataR;
                        var res = dataDia.replace("/", "-");
                        axios
                        .get(this.ruta + "/api/llistarTasques/" + res + "+" + this.idClient + "+" + this.idCentre)
                        .then(response => {
                            this.tasquesT = response.data;
                            for (let i = 0; i < this.limit; i++) {
                                while (j < this.tasquesT.length && sortir == false) {
                                    if (this.tasquesT[j].concepte_id == this.tasquesC[i].concepte_id) {
                                        sortir = true;
                                    } else {
                                        j++;
                                    }
                                }
                                k = 0;
                                fi = false;
                                if (sortir == false) {
                                    while (k < this.totesTasques.length && fi == false) {
                                        if (this.totesTasques[k].id == this.tasquesC[i].concepte_id && this.totesTasques[k].actiu == 1) {
                                            fi = true;
                                        } else {
                                            k++;
                                        }
                                    }

                                    if (fi == true) {
                                        text +='<option value="' + this.totesTasques[k].nomTasca + '">';
                                    }
                                }
                                j = 0;
                                sortir = false;
                            }
                            tasquesL.innerHTML = text;
                            text = "";
                        });
                    });
                });
            } else {
                document.getElementById("tasques").disabled = true;
            }
        },
        getTreballadors() {
            var treballadorsL = document.getElementById("treballadorsL");
            var text = "";
            axios.get(this.ruta + "/api/treballadors").then(response => {
                this.treballadorsT = response.data;
                for (let i = 0; i < this.treballadorsT.length; i++) {
                    text += '<option value="' + this.treballadorsT[i].nom + '">' + this.treballadorsT[i].cifDni + '</option>';
                }
                treballadorsL.innerHTML = text;
                text = "";
            });
        },
        guardarD() {
            this.loading = true;
            var nomTasca = document.getElementById("tasques").value;
            var res = nomTasca.replace(" ", "-");
            nomTasca = res;
            var nomTreballador = document.getElementById("treballadors").value;
            var tascaId = [];
            var treballdorId = [];
            var okTasca = true;
            var okTreballador = true;
            var okunitat = true;
            var okTemps = true;
            if (nomTasca == "") {
                document.getElementById("tasquesE").style.visibility = "visible";
                okTasca = false;
            } else {
                document.getElementById("tasquesE").style.visibility = "hidden";
                okTasca = true;
            }
            if (nomTreballador == "") {
                document.getElementById("treballadorE").style.visibility = "visible";
                okTreballador = false;
            } else {
                document.getElementById("treballadorE").style.visibility = "hidden";
                okTreballador = true;
            }
            if (document.getElementById("unitats").value < 1 || document.getElementById("unitats").value == "") {
                document.getElementById("unitatsE").style.visibility = "visible";
                okunitat = false;
            } else {
                document.getElementById("unitatsE").style.visibility = "hidden";
                okunitat = true;
            }
            if (document.getElementById("tempsTeoricTotal").value == "00:00" ||document.getElementById("tempsTeoricTotal").value == "") {
                document.getElementById("tempsTeoricTotalE").style.visibility = "visible";
                okTemps = false;
            } else {
                document.getElementById("tempsTeoricTotalE").style.visibility = "hidden";
                okTemps = true;
            }
            if (document.getElementById("tempsRealTotal").value == "00:00") {
                document.getElementById("tempsRealTotal").value = document.getElementById("tempsTeoricTotal").value;
            }
            if (okTasca == true && okTreballador == true && okunitat == true && okTemps == true) {
                axios
                .get(this.ruta + "/api/comprovarTasca/" + nomTasca)
                .then(response => {
                    tascaId = response.data;
                    axios
                    .get(this.ruta + "/api/treballador/" + nomTreballador)
                    .then(response => {
                        treballdorId = response.data;
                        this.guardar(tascaId[0].id, treballdorId[0].id);
                    });
                });
            } else {
                this.loading = false;
            }
        },
        guardar($tascaId, $treballadorId) {
            this.feinaTreballador.client_id = this.idClient;
            this.feinaTreballador.centre_id = this.idCentre;
            this.feinaTreballador.data = document.getElementById("dataDia").value;
            this.feinaTreballador.concepte_id = $tascaId;
            this.feinaTreballador.treballador_id = $treballadorId;
            this.feinaTreballador.unitats = document.getElementById("unitats").value;
            this.feinaTreballador.tempsTeoricUnitari = document.getElementById("tempsTeoricUnitari").value;
            this.feinaTreballador.tempsTeoricTotal = document.getElementById("tempsTeoricTotal").value;
            this.feinaTreballador.tempsRealTotal = document.getElementById("tempsRealTotal").value;
            this.feinaTreballador.actiu = 0;
            axios
            .post(this.ruta + "/api/addFeinaTreballador", {
                client_id: this.feinaTreballador.client_id,
                centre_id: this.feinaTreballador.centre_id,
                data: this.feinaTreballador.data,
                concepte_id: this.feinaTreballador.concepte_id,
                treballador_id: this.feinaTreballador.treballador_id,
                unitats: this.feinaTreballador.unitats,
                tempsTeoricUnitari: this.feinaTreballador.tempsTeoricUnitari,
                tempsTeoricTotal: this.feinaTreballador.tempsTeoricTotal,
                tempsRealTotal: this.feinaTreballador.tempsRealTotal,
                actiu: this.feinaTreballador.actiu
            })
            .then(response => {
                document.getElementById("tasques").value = null;
                document.getElementById("treballadors").value = null;
                document.getElementById("dataDia").value = null;
                document.getElementById("unitats").value = null;
                document.getElementById("tempsTeoricUnitari").value = "00:00";
                document.getElementById("tempsTeoricTotal").value = "00:00";
                document.getElementById("tempsRealTotal").value = "00:00";
                this.getData();
            })
            .finally(() => (this.loading = false));
        },
        llistarTasques() {
            var dataDia = this.dataR;
            var res = dataDia.replace("/", "-");
            var j = 0;
            var sortir = false;
            axios.get(this.ruta + "/api/treballadors").then(response => {
                this.totsTreballadors = response.data;
                axios.get(this.ruta + "/api/tasques").then(response => {
                    this.totesTasques = response.data;
                    axios
                    .get(this.ruta + "/api/llistarTasques/" + res + "+" + this.idClient + "+" + this.idCentre)
                    .then(response => {
                        this.tascaFeines = response.data;
                        for (let i = 0; i < this.tascaFeines.length; i++) {
                            while (j < this.totesTasques.length && sortir == false) {
                                if (this.totesTasques[j].id == this.tascaFeines[i].concepte_id) {
                                    sortir = true;
                                    this.tascaFeines[i].concepte_id = this.totesTasques[j].nomTasca;
                                } else {
                                    j++;
                                }
                            }
                            if (this.tascaFeines[i].validat == 1) {
                                document.getElementById("btn-afegir").disabled = true;
                                document.getElementById("btn-validar").disabled = true;
                                document.getElementById("tasques").disabled = true;
                                document.getElementById("treballadors").disabled = true;
                                document.getElementById("unitats").disabled = true;
                                document.getElementById("tempsTeoricUnitari").disabled = true;
                                document.getElementById("tempsTeoricTotal").disabled = true;
                                document.getElementById("tempsRealTotal").disabled = true;
                            } else {
                                document.getElementById("btn-afegir").disabled = false;
                                document.getElementById("btn-validar").disabled = false;
                                document.getElementById("tasques").disabled = false;
                                document.getElementById("treballadors").disabled = false;
                                document.getElementById("unitats").disabled = false;
                                document.getElementById("tempsTeoricUnitari").disabled = false;
                                document.getElementById("tempsTeoricTotal").disabled = false;
                                document.getElementById("tempsRealTotal").disabled = false;
                            }
                            j = 0;
                            sortir = false;
                            while (j < this.totsTreballadors.length && sortir == false) {
                                if (this.totsTreballadors[j].id == this.tascaFeines[i].treballador_id) {
                                    sortir = true;
                                    this.tascaFeines[i].treballador_id = this.totsTreballadors[j].nom;
                                } else {
                                    j++;
                                }
                            }
                            j = 0;
                            sortir = false;
                        }
                    })
                    .finally(() => (this.loading = false));
                });
            });
        },
        validarConceptes() {
            if (this.tascaFeines.length > 0) {
                if (confirm("Estàs segur de validar els conceptes introduïts?")) {
                    this.loading = true;
                    var dataDia = this.dataR;
                    var res = dataDia.replace("/", "-");
                    axios
                    .get(this.ruta + "/api/llistarTasques/" + res + "+" + this.idClient + "+" + this.idCentre)
                    .then(response => {
                        this.tascaFeines = response.data;
                        for (let i = 0; i < this.tascaFeines.length; i++) {
                            axios
                            .post(this.ruta + "/api/validar/" + this.tascaFeines[i].id, {
                                actiu: true
                            })
                            .then(response => {
                                document.getElementById("btn-afegir").disabled = true;
                                document.getElementById("btn-validar").disabled = true;
                                document.getElementById("tasques").disabled = true;
                                document.getElementById("treballadors").disabled = true;
                                document.getElementById("dataDia").disabled = true;
                                document.getElementById("unitats").disabled = true;
                                document.getElementById("tempsTeoricUnitari").disabled = true;
                                document.getElementById("tempsTeoricTotal").disabled = true;
                                document.getElementById("tempsRealTotal").disabled = true;
                            });
                        }
                        this.getData();
                    });
                }
            } else {
                alert("No hi ha tasques per validar");
            }
        }
    },
    mounted: function() {
        console.log("Component mounted.");
        document.getElementById("tempsTeoricUnitari").value = "00:00";
        document.getElementById("tempsTeoricTotal").value = "00:00";
        document.getElementById("tempsRealTotal").value = "00:00";
        this.getDataDia();
        this.getClients();
        this.getTreballadors();
    }
};
</script>
